"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var schema_service_1 = require("../services/schema/schema.service");
var Api_service_1 = require("../services/api/Api.service");
var property_pipe_1 = require("../pipes/property.pipe");
var Config_service_1 = require("../services/config/Config.service");
var _ = require("lodash");
var ListComponent = (function () {
    function ListComponent(schemaService, api, config) {
        this.schemaService = schemaService;
        this.api = api;
        this.config = config;
        this.properties = [];
    }
    ListComponent.prototype.routerOnActivate = function (segment) {
        var _this = this;
        var modelName = segment.getParam('model');
        this.schemaService.schema
            .filter(function (schema) { return null !== schema; })
            .map(function (schema) { return schema.models; })
            .switchMap(function (model) { return model; })
            .filter(function (model) { return model.title === modelName; })
            .subscribe(function (model) {
            _this.model = model;
            _this.extractProperties();
            _this.getCollection();
        });
    };
    ListComponent.prototype.extractProperties = function () {
        var _this = this;
        var availableProps = this.config.get(this.model.title + ".List.enableFields");
        if (null === availableProps) {
            this.properties = this.model.properties;
        }
        else {
            this.model.properties.forEach(function (property) {
                if (availableProps.includes(property.label)) {
                    _this.properties.push(property);
                }
            });
            this.sortProperties();
        }
    };
    ListComponent.prototype.sortProperties = function () {
        var availableProps = this.config.get(this.model.title + ".List.enableFields");
        if (null !== availableProps) {
            this.properties = _.sortBy(this.properties, function (property) {
                return _.indexOf(availableProps, property.label);
            });
        }
    };
    ListComponent.prototype.getCollection = function () {
        var _this = this;
        this.api.getCollection(this.model.title)
            .subscribe(function (collection) { return _this.collection = collection; });
    };
    ListComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'app-list',
            templateUrl: 'list.component.html',
            styleUrls: ['list.component.css'],
            providers: [Api_service_1.APIService],
            pipes: [property_pipe_1.PropertyPipe]
        }), 
        __metadata('design:paramtypes', [schema_service_1.SchemaService, Api_service_1.APIService, Config_service_1.ConfigService])
    ], ListComponent);
    return ListComponent;
}());
exports.ListComponent = ListComponent;
//# sourceMappingURL=list.component.js.map