"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var sidenav_1 = require("@angular2-material/sidenav/sidenav");
var list_1 = require("@angular2-material/list/list");
require('rxjs/add/operator/filter');
require('rxjs/add/operator/map');
var sidenav_service_1 = require("./sidenav.service");
var schema_service_1 = require("../services/schema/schema.service");
var ContentComponent = (function () {
    function ContentComponent(sidenavService, schemaService) {
        this.sidenavService = sidenavService;
        this.schemaService = schemaService;
        this.models = [
            { title: 'Home', link: ['/home'] }
        ];
    }
    ContentComponent.prototype.initSidenav = function () {
        var _this = this;
        this.sidenavService.onChange.subscribe(function (event) {
            if (undefined !== _this.sidenav && undefined !== _this.sidenav[event.name]) {
                _this.sidenav[event.name]();
            }
        });
    };
    ContentComponent.prototype.initModels = function () {
        var _this = this;
        this.modelsObserver = this.schemaService.schema
            .filter(function (schema) { return null !== schema; })
            .map(function (schema) { return schema.models; })
            .subscribe(function (models) {
            _this.models = _this.models.concat(models);
        });
    };
    ContentComponent.prototype.closeSidenav = function () {
        this.sidenavService.change('close');
    };
    ContentComponent.prototype.ngOnInit = function () {
        this.initSidenav();
        this.initModels();
    };
    ContentComponent.prototype.ngOnDestroy = function () {
        this.sidenavService.onChange.unsubscribe();
        if (undefined !== this.modelsObserver) {
            this.modelsObserver.unsubscribe();
        }
    };
    __decorate([
        core_1.ViewChild(sidenav_1.MdSidenav), 
        __metadata('design:type', sidenav_1.MdSidenav)
    ], ContentComponent.prototype, "sidenav", void 0);
    ContentComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'app-content',
            templateUrl: 'content.component.html',
            styleUrls: ['content.component.css'],
            directives: [sidenav_1.MD_SIDENAV_DIRECTIVES, list_1.MD_LIST_DIRECTIVES, router_1.ROUTER_DIRECTIVES]
        }), 
        __metadata('design:paramtypes', [sidenav_service_1.SidenavService, schema_service_1.SchemaService])
    ], ContentComponent);
    return ContentComponent;
}());
exports.ContentComponent = ContentComponent;
//# sourceMappingURL=content.component.js.map