"use strict";
var _ = require('lodash');
require('rxjs/add/operator/filter');
exports.COLLECTION_METHOD = 'GET_COLLECTION';
exports.entrypointHelper = {
    filterEntryPoints: function (datas) {
        return _.omit(datas, ['@context', '@id', '@type']);
    },
    filterSupportedClass: function (datas) {
        return _.filter(datas, function (item) {
            return _.findIndex(['#ConstraintViolation', '#ConstraintViolationList'], (function (needle) { return needle === item['@id']; })) === -1;
        });
    },
    getEntryPointByModel: function (model, entrypoints) {
        return _.find(entrypoints, (function (entrypoint) { return entrypoint.model === model; }));
    },
    getModelById: function (id) {
        return id.substr(id.lastIndexOf('/') + 1);
    },
    getOperations: function (supportedOperations, definition) {
        return _.map(supportedOperations, (function (operation) {
            return (operation[definition.method] && operation.returns === definition.PagedCollection) ? exports.COLLECTION_METHOD : operation[definition.method];
        }));
    }
};
//# sourceMappingURL=entrypointHelper.js.map