"use strict";
var _ = require('lodash');
var Model_1 = require('../services/models/Model');
exports.schemaHelper = {
    getSchemaTitle: function (datas, definition) {
        return datas[definition.title];
    },
    populateModels: function (datas, definition) {
        return _.map(exports.schemaHelper.cleanModelsList(datas[definition.supportedClass]), function (item) {
            return exports.schemaHelper.populateModel(item, definition);
        });
    },
    populateModel: function (model, definition) {
        if (model === void 0) { model = {}; }
        if (definition === void 0) { definition = {}; }
        return new Model_1.Model(model, definition);
    },
    cleanModelsList: function (supportedClasses) {
        if (undefined !== supportedClasses) {
            var supportedClasse = supportedClasses.filter(function (item) {
                return item['@id'].match('/*.schema.org.*/');
            });
            return supportedClasse;
        }
        return null;
    }
};
//# sourceMappingURL=schemaHelper.js.map