"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var router_1 = require('@angular/router');
var button_1 = require('@angular2-material/button');
var icon_1 = require('@angular2-material/icon');
var Config_service_1 = require('./services/config/Config.service');
var CoreDefinition_service_1 = require('./services/core/CoreDefinition.service');
var schema_service_1 = require('./services/schema/schema.service');
var index_1 = require('./header/index');
var index_2 = require('./content/index');
var _home_1 = require('./+home');
var _list_1 = require('./+list');
exports.HmAdminRoutes = [
    new router_1.Route({ path: '/', component: _home_1.HomeComponent }),
    new router_1.Route({ path: '/home', component: _home_1.HomeComponent }),
    new router_1.Route({ path: '/list/:model', component: _list_1.ListComponent })
];
var HmAdminComponent = (function () {
    function HmAdminComponent(configService, coreDefinitionService, schemaService) {
        this.configService = configService;
        this.coreDefinitionService = coreDefinitionService;
        this.schemaService = schemaService;
    }
    HmAdminComponent.prototype.ngOnInit = function () {
        this.configService.setConfiguration(this.config);
        this.coreDefinitionService.loadDefinitions();
        this.schemaService.load();
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], HmAdminComponent.prototype, "config", void 0);
    HmAdminComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'hm-admin-app',
            templateUrl: 'hm-admin.component.html',
            styleUrls: ['hm-admin.component.css'],
            providers: [
                http_1.HTTP_PROVIDERS,
                icon_1.MdIconRegistry,
                Config_service_1.ConfigService,
                CoreDefinition_service_1.CoreDefinitionService,
                schema_service_1.SchemaService,
                index_2.SidenavService
            ],
            directives: [button_1.MdButton, icon_1.MdIcon, index_1.HeaderComponent, index_2.ContentComponent],
            encapsulation: core_1.ViewEncapsulation.None
        }), 
        __metadata('design:paramtypes', [Config_service_1.ConfigService, CoreDefinition_service_1.CoreDefinitionService, schema_service_1.SchemaService])
    ], HmAdminComponent);
    return HmAdminComponent;
}());
exports.HmAdminComponent = HmAdminComponent;
//# sourceMappingURL=hm-admin.component.js.map