"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
require('rxjs/add/operator/map');
require('rxjs/add/operator/mergeMap');
require('rxjs/add/operator/do');
var Config_service_1 = require('../config/Config.service');
var schema_service_1 = require('../schema/schema.service');
var entrypointHelper_1 = require('../../helper/entrypointHelper');
var stringHelper_1 = require('../../helper/stringHelper');
var pagedCollection_1 = require('../models/pagedCollection');
var CoreDefinition_service_1 = require('../core/CoreDefinition.service');
require('rxjs/add/operator/switchMap');
var APIService = (function () {
    function APIService(http, config, schema, coreDefinitionService) {
        var _this = this;
        this.http = http;
        this.config = config;
        this.schema = schema;
        this.coreDefinitionService = coreDefinitionService;
        this.entrypoints = [];
        this.schema.entrypoints.subscribe(function (entrypoints) { return _this.entrypoints = entrypoints; });
    }
    APIService.prototype.getCollectionByUrl = function (path) {
        var _this = this;
        var query = this.http.get(path);
        query.subscribe(null, function () {
            throw Error("API's url is unreachable: " + path + ".");
        });
        return query
            .map(function (data) { return data.json(); })
            .map(function (collection) { return pagedCollection_1.pagedCollection(collection, _this.coreDefinitionService); })
            .switchMap(function (collection) { return collection; });
    };
    APIService.prototype.getCollection = function (modelName) {
        if (modelName === void 0) { modelName = ''; }
        var cleanName = stringHelper_1.stringHelper.toCamelCase(modelName), entrypoint = entrypointHelper_1.entrypointHelper.getEntryPointByModel(cleanName, this.entrypoints);
        if (undefined === entrypoint || '' === modelName) {
            throw Error("Can't find an entrypoint for " + modelName + " in " + this.entrypoints);
        }
        return this.getCollectionByUrl(this.config.get('api.baseUrl') + entrypoint.url);
    };
    APIService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, Config_service_1.ConfigService, schema_service_1.SchemaService, CoreDefinition_service_1.CoreDefinitionService])
    ], APIService);
    return APIService;
}());
exports.APIService = APIService;
//# sourceMappingURL=Api.service.js.map