"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var http_1 = require('@angular/http');
var core_1 = require('@angular/core');
var rxjs_1 = require('rxjs');
require('rxjs/add/operator/map');
require('rxjs/add/observable/of');
var Config_service_1 = require('../config/Config.service');
var CoreDefinitionService = (function () {
    function CoreDefinitionService(http, configService) {
        this.http = http;
        this.configService = configService;
        this.definitions = new rxjs_1.BehaviorSubject({});
    }
    CoreDefinitionService.prototype.loadDefinitions = function () {
        var _this = this;
        this.getDefinitions().subscribe(function (definitions) {
            var definitionList = {};
            for (var key in definitions) {
                var value = definitions[key];
                if (typeof value === 'object'
                    && !(value instanceof String)) {
                    if (value.hasOwnProperty('@id')) {
                        _this.add(key, value['@id'], definitionList);
                    }
                }
                else {
                    _this.add(key, value, definitionList);
                }
            }
            localStorage.setItem('definitions', JSON.stringify(definitionList));
            _this.definitions.next(definitionList);
        });
    };
    CoreDefinitionService.prototype.getDefinitions = function () {
        var definitions;
        if ((definitions = localStorage.getItem('definitions')) !== null) {
            return rxjs_1.Observable.of(JSON.parse(definitions));
        }
        return this.http.get(this.configService.get('api.definitionUrl'))
            .map(function (res) { return res.json(); })
            .map(function (res) { return res['@context']; });
    };
    CoreDefinitionService.prototype.add = function (key, value, object) {
        Object.defineProperty(object, key, {
            value: value,
            writable: false,
            enumerable: true
        });
    };
    CoreDefinitionService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, Config_service_1.ConfigService])
    ], CoreDefinitionService);
    return CoreDefinitionService;
}());
exports.CoreDefinitionService = CoreDefinitionService;
//# sourceMappingURL=CoreDefinition.service.js.map