"use strict";
var testing_1 = require('@angular/core/testing');
var EntryPoint_1 = require('../models/EntryPoint');
testing_1.describe('Entrypoint model', function () {
    testing_1.describe('#constructor', function () {
        var entrypoint;
        testing_1.beforeEach(function () {
            entrypoint = new EntryPoint_1.EntryPoint();
        });
        testing_1.it('should have an empty model as default', function () {
            testing_1.expect(entrypoint.model).toBeDefined();
            testing_1.expect(entrypoint.model).toBe('');
        });
        testing_1.it('should have empty operations array as default', function () {
            testing_1.expect(entrypoint.operations).toBeDefined();
            testing_1.expect(Array(entrypoint.operations)).toBeTruthy();
            testing_1.expect(entrypoint.operations.length).toBe(0);
        });
        testing_1.it('should set model name', function () {
            entrypoint = new EntryPoint_1.EntryPoint('blogPosting');
            testing_1.expect(entrypoint.model).toBe('blogPosting');
        });
    });
    testing_1.describe('#addOperations', function () {
        var entrypoint;
        testing_1.beforeEach(function () {
            entrypoint = new EntryPoint_1.EntryPoint();
        });
        testing_1.it('should accept string as addition', function () {
            entrypoint.addOperations('GET');
            testing_1.expect(entrypoint.operations.length).toBe(1);
            testing_1.expect(entrypoint.operations).toContain('GET');
        });
        testing_1.it('should accept array as addition', function () {
            entrypoint.addOperations(['GET', 'POST']);
            testing_1.expect(entrypoint.operations.length).toBe(2);
            testing_1.expect(entrypoint.operations).toContain('GET');
            testing_1.expect(entrypoint.operations).toContain('POST');
            entrypoint.addOperations('DELETE');
            testing_1.expect(entrypoint.operations.length).toBe(3);
            testing_1.expect(entrypoint.operations).toContain('DELETE');
        });
        testing_1.it('should refuse other types as addition', function () {
            entrypoint.addOperations(function () { return null; });
            entrypoint.addOperations({ 'GET': true });
            testing_1.expect(entrypoint.operations.length).toBe(0);
        });
        testing_1.it('should dedupe addition', function () {
            entrypoint.addOperations(['GET', 'POST']);
            entrypoint.addOperations('GET');
            testing_1.expect(entrypoint.operations.length).toBe(2);
        });
    });
});
//# sourceMappingURL=Entrypoint.spec.js.map