"use strict";
var _ = require('lodash');
var Property_1 = require('./Property');
var Model = (function () {
    function Model(datas, definition) {
        if (datas === void 0) { datas = {}; }
        if (definition === void 0) { definition = {}; }
        if (datas) {
            this.title = datas[definition.title] || '';
            this.description = datas[definition.description] || '';
            this.properties = undefined !== datas[definition.supportedProperty] ? this.getProperties(datas[definition.supportedProperty], definition) : [];
            this.link = datas.link || ['/list/', this.title];
        }
    }
    Model.prototype.getProperties = function (properties, definition) {
        return _.map(properties, function (property) { return new Property_1.Property(property, definition); });
    };
    return Model;
}());
exports.Model = Model;
//# sourceMappingURL=Model.js.map