"use strict";
var testing_1 = require('@angular/core/testing');
var Property_1 = require('../models/Property');
testing_1.describe('Property model', function () {
    testing_1.describe('#constructor', function () {
        testing_1.it('should set properties', function () {
            var property = new Property_1.Property({
                'hydra:title': 'firstName',
                'hydra:property': { '@type': 'rdf:Property' },
                'hydra:range': 'xmls:string',
                'hydra:required': true,
                'hydra:readable': true,
                'hydra:writable': true
            }, {
                'title': 'hydra:title',
                'property': 'hydra:property',
                'range': 'hydra:range',
                'required': 'hydra:required',
                'readable': 'hydra:readable',
                'writable': 'hydra:writable'
            });
            testing_1.expect(property.label).toBe('firstName');
            testing_1.expect(property.type).toBe('rdf:Property');
            testing_1.expect(property.range).toBe('xmls:string');
            testing_1.expect(property.required).toBeTruthy();
            testing_1.expect(property.readable).toBeTruthy();
            testing_1.expect(property.writable).toBeTruthy();
        });
        testing_1.it('should set default values', function () {
            var property = new Property_1.Property({
                'hydra:title': undefined,
                'hydra:property': undefined,
                'hydra:range': undefined,
                'hydra:required': undefined,
                'hydra:readable': undefined,
                'hydra:writable': undefined
            }, {
                'title': 'hydra:title',
                'property': 'hydra:property',
                'range': 'hydra:range',
                'required': 'hydra:required',
                'readable': 'hydra:readable',
                'writable': 'hydra:writable'
            });
            testing_1.expect(property.label).toBe('');
            testing_1.expect(property.type).toBe('');
            testing_1.expect(property.range).toBe('');
            testing_1.expect(property.required).toBeFalsy();
            testing_1.expect(property.readable).toBeTruthy();
            testing_1.expect(property.writable).toBeFalsy();
        });
    });
});
//# sourceMappingURL=Property.spec.js.map