import { Http } from '@angular/http';
import { Observable, BehaviorSubject } from 'rxjs';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/switchMap';
import 'rxjs/add/operator/share';
import { ConfigService } from '../config/Config.service';
import { EntryPoint } from '../models/EntryPoint';
import { CoreDefinitionService } from '../core/CoreDefinition.service';
export declare class SchemaService {
    private http;
    private config;
    private coreDefinitionService;
    schema: BehaviorSubject<any>;
    entrypoints: BehaviorSubject<Array<EntryPoint>>;
    availableEntrypoints: Array<EntryPoint>;
    constructor(http: Http, config: ConfigService, coreDefinitionService: CoreDefinitionService);
    load(): void;
    loadRoot(): void;
    loadDocumentation(definition: any): void;
    loadCollectionOperations(api: Observable<any>, definition: any): void;
    loadSingleOperations(api: Observable<any>, definition: any): void;
    loadSchema(apidoc: Observable<any>, definition: any): void;
}
